#ifndef __video__
#define __video__


#define INPUT_STATUS        0x03da
#define VRETRACE            0x08

#define _1x4 	40
#define _2x2	80
#define _4x1	120
#define SIZE_C4 _2x2

typedef struct {
	unsigned long xsize;
	unsigned long ysize;
	unsigned char *mask;
	char *bitmap;
} prep_image;
		  


static const unsigned char font [] = 
   {0,0,0,0,1,2,3,4,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,
    1,1,0,0,0,0,0,2,0,0,0,0,1,1,0,0,
    0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
    3,3,4,2,4,2,1,1,1,2,2,2,4,2,2,2,
    0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,2,0,0,0,0,0,0,1,0,
    0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,

    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};





void move_to(unsigned x, unsigned y);
void clrscr(void);
void clrscr_c4(unsigned char color);
void putpixel (long x, long y, unsigned char color);
void setpixel (long x, long y, unsigned char color);
void putpixel_c4 (long x, long y, unsigned char color);
prep_image* planify (unsigned char *bitmap, unsigned long xsize, unsigned long ysize);


// void line (float x1, float y1, float x2, float y2);
void line (long x1, long y1, long x2, long y2);
void line_c4 (long x1, long y1, long x2, long y2);



void put_gfx_char (unsigned long xpos, unsigned long ypos, unsigned char color);
void cursor_yx (unsigned int y, unsigned int x);    
void scroll (unsigned char);
void wait_retrace(void);

#endif
