#include "x86.h"
#include "stdio.h"
inline void ata_identify_drive (unsigned char disc_no)
    
  {
    
    ident_drive_struct hd;
     
     ata_wait();    			/* wait until drive not busy */

     disable();     			/*disables interrupts*/


     ata_drive_ready();    		/*waits until drive ready*/
     ata_select( 0x0 );  		/* chooses device */

     
     outportb(ata_cmd_stat_register, ata_command_identify_drive );

     ata_data_ready();


      insw (ata_data_register, (unsigned short*) &hd , 255);

     
     enable();  		  /*enables interrupt */
     
/*     lim(0,40,hd.model_number, 160*3 );
*/

     printf ("%x", ( hd.no_of_removable_cylinders)  );
      
     if (hd.configuration_id & hard_sectored)
       printf ("\n", "Hard Sectored Disc");

	
     if (hd.configuration_id & soft_sectored)
        printf ("\n", "soft Sectored Disc");
      
     if (hd.configuration_id & not_mfm_encoded)
        printf ("%n", "Not mfm encoded  disc");
      
     if (hd.configuration_id & head_switching_time_above_15us)
        printf ("\n", "Head switching time above 15 ms");
     
     if (hd.configuration_id & spindle_motor_can_be_switched_off)
        printf ("\n", "Spindle motor can be switched off");
     
     if (hd.configuration_id & non_removable_disk)
        printf ("%n", "non removable disc");
      
     if (hd.configuration_id & removable_disk)
        printf ("\n", "removable_disc");
     
     if (hd.configuration_id & dtr_lower_5mbsec)
        printf ("\n", "Data transfer rate < 5mb per Sec");
     
     if (hd.configuration_id & dtr_lower_10_higher_5mbsec)
        printf ("\n", "Data transfer rate > 5 mb per sec but < 10 mb per sec ");
     
     if (hd.configuration_id & dtr_higher_10mbsec)
        printf ("\n", "Data transfer rate > 10 mb per sec");
     
     if (hd.configuration_id & rotational_frequency_tolerance_above_05)
        printf ("\n", "Rotational frequency tolerance above 0.5");
     
     if (hd.configuration_id & data_strobe_offset_option_avaliable)
        printf ("\n", "Data strobe offset option avaliable");
     
     if (hd.configuration_id & track_offset_option_avaliable)
        printf ("\n", "Track offset option avaliable");
     
     if (hd.configuration_id & format_speed_tolerance_gap_required)
        printf ("\n", "Format speed tolerance gap required");
     
     if (hd.configuration_id & non_magnetic_drive)
        printf ("\n", "Non magnetic drive");

      printf("%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n%s%d\n", "Number of fixed cylinders: ", 
      hd.no_of_fixed_cylinders, "no_of_removable_cylinders: ",hd.no_of_removable_cylinders,
      "Number of heads: ", hd.no_of_heads, "Number of unformatted bytes per physical track: ",
      hd.no_of_unformatted_bytes_per_physical_track, "Number of unformatted bytes per sector: ",
      hd.no_of_unformatted_bytes_per_sector, "Number of physical sectores per track: ",
      hd.no_of_physical_sectors_per_track, "Number of bytes in the intersector gaps: ",
      hd.no_of_bytes_in_the_intersector_gaps, "Number of bytes in the sync fields: ",
      hd.no_of_bytes_in_the_sync_fields );     
     
      
      printf("Firmware Revision: ");
      printf("%s%i%n", "Controller type: " , hd.controller_type);
            	
       switch (hd.controller_type)
         {          
           case 0 : printf ("\n", "Controller type: ","Not specified.");
           case 1 : printf ( "\n", "Controller type: ","Single ported, single sector buffer.");
           case 2 : printf ( "\n", "Controller type: ","Dual ported, multiple sector buffer.");
           case 3 : printf ( "\n", "Controller type: ","Dual ported, multiple sector buffer and look-ahead read capabilities.");
	 }
	
    printf("\n");	 
    printf("\n","HD model number: ");
//    lim_HOB(consobj->y,17,hd.model_number,40);
    
     printf("%s%i\n", "Number of sectors / interrupt: ",hd.no_of_sectors_interrupt);    	   
    if (hd.double_word_transfer_flag == 1)
       printf("\n", "Double word transfer flag Enabled." );	         
     
     /*  loop=0;
     */  
     if (hd.write_protected == 1)
       printf ("%s\n", "Write protected.") ;            
    //  to_binary_string(hd.controller_type);	


  }

