#include "hd.h"
#include "x86.h"
#include "stdio.h"

inline	void
ata_wait(void)
{
    __asm__ __volatile__ ("mov	$0x1f7, %%dx;"
			  "loop1:;"
			  "in	%%dx, %%al;"
			  "and	$128, %%al;"
			  "jne	loop1;"
			  
			  :
			  : );
}


inline	void
ata_drive_ready(void)
{
    __asm__ __volatile__ ("mov	$0x1f7, %%dx;"
			  "loop2:;"
			  "in	%%dx, %%al;"
			  "and	$64, %%al;"			// if bit 7 set
			  "je	loop2;"				// jump to loop2
			  :
			  : );
}

inline	void
ata_data_ready(void)
{
    __asm__ __volatile__ ("mov	$0x1f7, %%dx;"
			  "loop3:;"
			  "in	%%dx, %%al;"
			  "and	$8, %%al;"			// if bit 4 set
			  "je	loop3;"				// jump to loop3
			  :
			  : );
}

inline void ata_select ( unsigned char device)
  {
    unsigned char temp;
    temp = inportb (ata_device_and_head_register);
//    temp =  (temp && 0x10 || device) ; // hopefully this will work, It does a logical and on bit 4, and then a or as all can see.
   temp = (temp && 0xef == 0 ) ;    
   outportb (ata_device_and_head_register,  0xa0 );
  }
/* chooses device in master- slave chain */



inline void ata_hd_init ( int cyl, int head, int sec)
  {
    outportb (0x3f6, 6);
//    wait(10);
    outportb (0x3f6, 2);
    ata_wait();
    
    outportb (ata_sector_count, sec);

    outportb (ata_cylinder_low, cyl );
    outportb (ata_cylinder_high,cyl >> 8 ) ;

//    outb (ata_cylinder_low, 0 );
//    outb (ata_cylinder_high, 0 );

    outportb (ata_SDH_register, 0xa0+head) ;
    
    ata_command(0x91);
  }  


 inline void ata_write_buf (unsigned int* buffer)
 {
   ata_data_ready();
   int l;
   for (l=0; l < 128; l++)
//     outportl(ata_data_register,buffer[l]);
     outportl(ata_data_register,ata_sec_buf[l]);
 
  ata_wait();  
 
 }

 inline void ata_read_buf (void)
 {
   ata_data_ready();
   int l;
   for (l=0; l < 128; l++)
//     outportl(ata_data_register,buffer[l]);
     inportl(ata_data_register,ata_sec_buf[l]);
 
  ata_wait();  
 
 }


inline void ata_write_sec (int cyl, int head, int sec, unsigned int* buffer)
  {
    ata_wait();
    outportb (ata_sector_count, 1);
    outportb (ata_sector_number, sec);
    
    outportb (ata_cylinder_low, cyl );
    outportb (ata_cylinder_high,cyl >> 8 ) ;

//    outb (ata_cylinder_low, 0 );
//    outb (ata_cylinder_high,0  );
    

//     outb (ata_SDH_register, 0xa0+head) ;
    
    outportb (ata_SDH_register, 0xa0) ;
    
    ata_command(0x30);
    ata_write_buf( (unsigned int*) buffer);

    
  }

inline void ata_read_sec (int cyl, int head, int sec)
  {
    ata_wait();
    outportb (ata_sector_count, 1);
    outportb (ata_sector_number, sec);
    
    outportb (ata_cylinder_low, cyl );
    outportb (ata_cylinder_high,cyl >> 8 ) ;

//    outb (ata_cylinder_low, 0 );
//    outb (ata_cylinder_high,0  );
    

//     outb (ata_SDH_register, 0xa0+head) ;
    
    outportb (ata_SDH_register, 0xa0) ;
    
    ata_command(0x20);
    ata_read_buf();

    
  }

void 
add2sec  (unsigned *add, long count) 			//couldn't work around that count parameter, Sizeof doesn't work, it'll just return the size of the pointer.
{
    printf ("smutt: %d", sizeof(*add));
    long l;
    for (l =0; l < ( count >> 2) +1 ;  l++)
    {
	ata_sec_buf[l + ata_sec_offset] = (unsigned long) add[l];
    
//	ata_sec_buf[l + ata_sec_offset + 1] = add[l + 1];
//	ata_sec_buf[l + ata_sec_offset + 2] = add[l + 2];
//	ata_sec_buf[l + ata_sec_offset + 3] = add[l + 3];
    }

    
    ata_sec_offset+=sizeof(add);	
    
    
}



inline void ata_command (unsigned char command)
  {
    ata_wait();
    outportb (ata_cmd_stat_register, command);
  }

inline void ata_recalibrate (void)
{
    ata_command(0x10);
}
